/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab or GlobalMMCS,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *5) Products derived from this software may not be called GlobalMMCS,
 * nor may Indiana University or Community Grids Lab or GlobalMMCS appear
 * in their name, without prior written permission of ARTI.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */<%@ page contentType="text/html" language="java" import="cgl.globalmmcs.webserver.*, cgl.globalmmcs.webserver.sessionmgt.*"%>
<!-- this web page allows administrator to select the video mixer and create new video mixer -->
<%
    String   sess_id = (String)request.getAttribute("sessionID");
    VideoMixer [] VideoMixerList = ( VideoMixer[] )request.getAttribute("mixers");
    XGSPAVSessionManager manager = XGSPAVSessionManager.getInstance();
    ActiveSession sess  = manager.getActiveSession(sess_id);
%>
<html>
<head><LINK rel="stylesheet" type="text/css" href="full.css">
<title>
SelVideoMixer
</title>
</head>

<body>


<form name="menu" method="post" action="/globalmmcs/admin">
<%-- show all the existing --%>
<table  border="1" align="center" cellpadding="10">
  <tr><th colspan="4"> Video Mixer List  </th></tr>
  <tr><th></th><th>mixerID</th><th>mixerStreams</th><th>mixerPic</th></tr>
  <%
  	VideoMixer videomixer;
        if ( VideoMixerList != null ){
  	for (int i=0; i < VideoMixerList.length; i++ ) {
    		videomixer = VideoMixerList[i];
   %>
   <tr>
   <td>
   <input type="radio" name="mixerid" value="<%=videomixer.getMixerID()%>">
   </td>

   <td><%=videomixer.getMixerID()%></td>
   <td>
   <%   String [] mixed_stream_list = videomixer.getMixedString();
   	for (int j=0; j< mixed_stream_list.length; j++ ){
   %>
   		<p> <%=mixed_stream_list[j]%>
   <%	}   %>
   </td>
   <%  if ( (videomixer.getImgPath() != null ) ) { %>
   <td><a href="<%="images/"+videomixer.getImgPath() %>"><img src="<%="images/"+videomixer.getImgPath() %>" height=50 width=50 ></a></td>
   <%   }} %>
   </tr>
<% } %>
</table>

<%-- command button --%>
<table align="center">
<tr>
<td><input type="submit" name="Modify" value="Modify" onClick="document.menu.cmd.value='edit-video-mixer'"></td>
<td><input type="submit" name="Delete" value="Delete" onClick="document.menu.cmd.value='delete-video-mixer'"></td>
<td><input type="submit" name="CreateMixer" value="CreateMixer" onClick="document.menu.cmd.value='add-video-mixer'"></td>
</tr>
</table>
<input type="hidden" name="cmd" value="">
<input type="hidden" name="sessionid" value="<%=sess_id%>">

<!-- show all the stream list -->
<table  border="1" align="center" cellpadding="10">
<tr><th colspan="6"> All the Stream List  </th></tr>
   <%
     StreamBean[][] streams = sess.GetStreamList();
     for (int i=0; i < streams.length; i++ ) {
       StreamBean[] tmp_streamlist = streams[i];
       for ( int j=0; j < tmp_streamlist.length; j++ ) {
               StreamBean stream = tmp_streamlist[j];
   %>
   <tr>
   <td>
   <%  if ( "video".equals(stream.getStreamtype()) && stream.getActive() ) { %>
           <input type="checkbox" name="videosrc" value="<%=stream.getSsrc()%>">
   <% }  %>
   </td>
   <td><%=stream.getUsername()%></td>
   <td><%=stream.getStreamtype()%></td>
   <td><%=stream.getStrdescription()%></td>
   <td><%=stream.getSsrc()%></td>
   <td>
   <%  if ( "video".equals(stream.getStreamtype()) && (stream.getImgpath()).length() > 0 ) { %>
     <a href="<%=stream.getImgpath() %>"><img src="<%=stream.getImgpath() %>" height=50 width=50 ></a>
   <%   } %>
   </td>
</tr>
<% } } %>
</table>
</form>
</body>
</html>
