/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab or GlobalMMCS,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *5) Products derived from this software may not be called GlobalMMCS,
 * nor may Indiana University or Community Grids Lab or GlobalMMCS appear
 * in their name, without prior written permission of ARTI.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */<%@ page contentType="text/html" language="java" import="cgl.globalmmcs.webserver.*"%>
<jsp:useBean id="mem" class="cgl.globalmmcs.webserver.MemberBean" />
<jsp:useBean id="mine" class="cgl.globalmmcs.webserver.MemberBean" />
<jsp:useBean id="stream" class="cgl.globalmmcs.webserver.StreamBean" />
<%
   MemberBean [] mems = ( MemberBean[] )request.getAttribute("members");
   String	 sess_id = (String)request.getAttribute("sessionid");
   String	 room_id = (String)request.getAttribute("roomid");
   MemberBean    me = (MemberBean)request.getAttribute("me");
   StreamBean [][] streams = ( StreamBean[][] )request.getAttribute("streams");
   String	 checked_videosrc = (String)request.getAttribute("checked_videosrc");
   java.util.Vector	 checked_audiosrc = (java.util.Vector)request.getAttribute("checked_audiosrc");

   String	tooltype = (String)request.getAttribute("tooltype");
   String	deviceAddr = (String)request.getAttribute("deviceAddr");
%>
<html>
<head>
<title>
SessionWork
</title>
<% if ( deviceAddr != null ) { %>
<meta http-equiv="Refresh" content="<%=me.getRefreshtime()%>;URL=/globalmmcs/portal?cmd=enter-room&sessionid=<%=sess_id%>&roomid=<%=room_id%>&deviceAddr=<%=deviceAddr%>&tooltype=<%=tooltype%>">
<% } else { %>
<meta http-equiv="Refresh" content="<%=me.getRefreshtime()%>;URL=/globalmmcs/portal?cmd=enter-room&sessionid=<%=sess_id%>&roomid=<%=room_id%>&tooltype=<%=tooltype%>">
<% } %>
</head>
<body>
<h1>
Session Work Page
</h1>
<h2> Session <%=sess_id%> : Room : <%=room_id%> </h2>
<table  border="1" align="center" cellpadding="10">
<tr><th colspan="4"> Member List  </th></tr>
<%
  for (int i=0; i < mems.length; i++ ) {
    mem = mems[i];
    String userid = mem.getUserid();
    ActiveUserList userlist = ActiveUserList.getInstance();
    String username = (userlist.getUser(userid)).getUsername();


%>
<tr><td><%=mem.getUserid()%></td>
<td><%=username %></td>
<td><%=mem.getRoomid()%></td>
<td><%=mem.getRole()%></td></tr>
<% } %>

<form name="choice" method="post" action="/globalmmcs/portal">
<table  border="1" align="center" cellpadding="10">
<tr><th colspan="4"> Stream List  </th></tr>
<%
  for (int i=0; i < streams.length; i++ ) {
    StreamBean[] tmp_streamlist = streams[i];
    for ( int j=0; j < tmp_streamlist.length; j++ ) {
    	stream = tmp_streamlist[j];
%>
<tr>
<td>
<%  if ( "video".equals(stream.getStreamtype()) ) {
      if ( checked_videosrc != null && checked_videosrc == stream.getSsrc() ) { %>
   	<input type="radio" name="videosrc" value="<%=stream.getSsrc()%>" checked>
<% }else { %>
	<input type="radio" name="videosrc" value="<%=stream.getSsrc()%>">
<% } } else { %>
<%    if ( checked_audiosrc != null &&  checked_audiosrc.contains(stream.getSsrc() )) { %>
	<input type="checkbox" name="audiosrc" value="<%=stream.getSsrc()%>" checked>
<%    } else { %>
	<input type="checkbox" name="audiosrc" value="<%=stream.getSsrc()%>">
<% } } %>
</td>
<td><%=stream.getUsername()%></td>
<td><%=stream.getStreamtype()%></td>
<td><%=stream.getStrdescription()%></td>
<td><%=stream.getSsrc()%></td>
<%  if ( "video".equals(stream.getStreamtype()) && (stream.getImgpath()).length() > 0 ) { %>
<td><a href="<%="images/"+stream.getImgpath() %>"><img src="<%="images/"+stream.getImgpath() %>" height=50 width=50 ></a></td>
<%   } %>
</tr>
<% } } %>

</table>



<table>
<tr>
<input type="text" name="RefreshTime" value="<%=me.getRefreshtime()%>" >
</tr>
<tr>
<input type="submit" name="ChangeRefresh" value="ChangRefresh" onClick ="document.choice.cmd.value='enter-room'">
<input type="submit" name="Logout" value="Logout" onClick="document.choice.cmd.value='logout'">
</tr>
<tr>
<input type="submit" name="ChangeRoom" value="ChangeRoom" onClick="document.choice.cmd.value='list-session'">
<input type="hidden" name="cmd" value="enter-room">
<input type="hidden" name="sessionid" value="<%=sess_id%>">
<input type="hidden" name="roomid" value="<%=room_id%>">
<input type="hidden" name="tooltype" value="<%=tooltype%>">
<input type="hidden" name="deviceAddr" value="<%=deviceAddr%>">
</tr>
</table>
</form>

<%   String roomaddr = me.getRoomaddr();
     if ( tooltype.equals("H323" )) {
	String callcommand = "callto:"+room_id;
%>
	<A HREF="<%=callcommand%>"> <b> Please make call before making choice </b>
	<p>
	<b> Device Addr <%= deviceAddr %> </b>
<% } else if ( tooltype.equals("AccessGrid")) { %>
	<A href = "test.wwj" > <b> Launtch VIC / RAT <b>
<% } else if ( tooltype.equals("SIP")) {
	XGSPConfiguration xgsp_conf = XGSPConfiguration.getInstance();
	String sipgw_addr = xgsp_conf.getSIPGW();
	String sip_url = "hearMe.jsp?sip_addr=sip:"+ room_id + "@" + sipgw_addr;
%>
	<A HREF="<%= sip_url %> " target=_blank > <b> Launtch SIP <b>
<% } %>
</body>
</html>
