/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab or GlobalMMCS,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *5) Products derived from this software may not be called GlobalMMCS,
 * nor may Indiana University or Community Grids Lab or GlobalMMCS appear
 * in their name, without prior written permission of ARTI.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */<html>
<head><LINK rel="stylesheet" type="text/css" href="full.css">
<title>
home for admin
</title>
<style type="text/css">
<!--
.style5 {font-family: Verdana, Arial, Helvetica, sans-serif}
-->
</style>
</head>
<body   bgcolor="#ffffff">     <br />
<div align="center"></div>
<h2  align="center" class="style5" >Global Multimedia Collaboration System </h2>
<hr>
<p><br>
  The Global-MMCS Project tries to build a collaboration system, which integrates various services including videoconference, instant messaging and streaming, support multiple videoconferencing technologies and heterogeneous collaboration environments.
<p>Research Scopes
<p align="justify">Collaboration systems enable people in remote places to communicate and cooperate together.&nbsp; It will bring substantial benefits to Internet users if we can build an integrated collaboration environment, which combines conferencing, streaming, instant messaging as well as other collaborations into a single easy-to-use, intuitive environment. However, traditional collaboration system can only provides limited collaboration capabilities to a small group people in a local or private community. They have features that sometimes can be compared but often the systems make implicit architecture and implementation assumptions that hamper interoperability and functionality. Therefore it is very important to create a more general framework to cover the wide range of collaboration solutions and allow different users from the different communities to collaborate.&nbsp; Since XML and Web Service provide the very powerful capability for meta-data and consturcting hetegenous distributed sytems, it is a very promising solution to build a general collaboration framework based on XML and Web Service technology. </p>
<p align="justify">To build an integrated large-scale multimedia collaboration system over heterogeneous network environments, we have to design a scalable computing architecture and flexible software framework. The Messaging event services provide publish-subscribe paradigm for all kinds of group communications in collaboration applications. And it is implemented in a distributed messaging broker middleware, which helps to ensure QoS requirements of various collaboration applications over diverse network environments. The Collaboration Web services framework defines a general architecture, which can integrate all the possible collaboration services, for example videoconferencing, streaming, IM as well as shared applications. On top of these services, all the services can be described, implemented and deployed. </p>
<p align="justify">XGSP defines web services framework in which H.323, SIP as well as MMUSIC could be integrated . We divide an A/V collaboration system into three parts: A/V application endpoints, session servers and multipoint communication channels provider. Each collaboration system has a different implementation for the application endpoints, server components and different communication protocols between them. Various collaboration systems including Access Grid, H.323 and SIP are regarded as Web-services components in XGSP framework. They provide Web-services interface of their conference control protocols to the XGSP collaboration manager servers so that their RTP and data channels can be connected with the XGSP&nbsp; media channel service under the control of the manager server.
<p>Research Areas :
<ul>
  <li>
    <p><strong>Videoconferencing with Web Services: </strong></p>
  </li>
</ul>
<p><strong>&nbsp;&nbsp;&nbsp;&nbsp; H.323, SIP, T.120, AccessGrid integration </strong></p>
<ul>
  <li><strong>Multimedia Event Service: </strong></li>
</ul>
<p>&nbsp;&nbsp;&nbsp;&nbsp; RTP over Narada </p>
<ul>
  <li><strong>Real Streaming and Achiving: </strong></li>
</ul>
<p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; provide RealStreaming and archiving service for videoconferencing and pro </p>
<ul>
  <li><strong>Instant Messaging : </strong></li>
</ul>
<p><strong></strong>integrate Instant Messaging and videoconferencing </p>
<hr>
<h3 align="center">Publications and Presentations </h3>
<p></p>

<br>
For an updated list of publications, please see the comprehensive publication list at the Community Grids web site. </p>
<p> A Web-Services based Conference Control Framework for Heterogenous A/V collaboration: By Wenjun Wu, Hasan Bulut, Ahmet Uyar, , Geoffrey C. Fox, 7th IASTED International Conference on INTERNET AND MULTIMEDIA SYSTEMS AND APPLICATIONS, August 13-15, 2003, Honolulu, Hawaii. Better version of XGSP Description. (PDF )<br>
  An Integrated Videoconferencing System for Heterogeneous Multimedia Collaboration: By Ahmet Uyar, Wenjun Wu, Hasan Bulut, Geoffrey Fox, 7th IASTED International Conference on INTERNET AND MULTIMEDIA SYSTEMS AND APPLICATIONS, August 13-15, 2003, Honolulu, Hawaii. ( PDF )</p>
<p>A Web Services Framework for Collaboration and Videoconferencing: By Geoffrey Fox, Wenjun Wu, Ahmet Uyar, Hasan Bulut, Shrideep Pallickara, Workshop of Advance Collaboration Environment (WACE) 2003, June 22, 2003 Seattle,summary of the project (MS Word Document)</p>
<p>Integration of SIP VoIP and Messaging Systems with AccessGrid and H.323 : Proceedings of 1st International Conference on Web Services Las Vegas June 2003, the paper describe how to integrate SIP based system using Web-services (MS Word Document). </p>
<p>Global Multimedia Collaboration System: By Geoffrey Fox, Wenjun Wu, Ahmet Uyar, Hasan Bulut, Shrideep Pallickara, June 15, 2003, Brazil. the overview of our current project (MS Word Document). </p>
<p>A Web Services Framework for Collaboration and Audio/Videoconferencing: By Geoffrey Fox, Wenjun Wu, Ahmet Uyar, Hasan Bulut, Proceedings of International Conference on Internet Computing, Las Vegas June 2003, the first paper describe our idea of the collaboration web service. (MS Word Document). </p>
<p></p>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p>&nbsp;</p>
</body>
</html>
