/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab or GlobalMMCS,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *5) Products derived from this software may not be called GlobalMMCS,
 * nor may Indiana University or Community Grids Lab or GlobalMMCS appear
 * in their name, without prior written permission of ARTI.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */
package cgl.globalmmcs.webserver;

import java.util.logging.*;

import com.mysql.jdbc.Driver;

import java.io.FileInputStream;
import java.io.IOException;

import java.sql.Connection;
import java.sql.DriverManager;


public class DBConnection {
	//private Logger logger = Logger.getLogger (this.getClass ().getName ());
	private java.util.logging.Logger logger = java.util.logging.Logger.getLogger (this.
			 getClass ().getName ());

	// private static org.apache.log4j.Logger logger = org.apache.log4j.Logger.getLogger (DBConnection.class);

	private Connection connection = null;

	public DBConnection () throws Exception {
		logger.info ("DBConnection ... ctor");

		String url = "";
		String driver = "";
		String username = "";
		String password = "";
		String connectString = "";

		url = "jdbc:mysql://complexity.ucs.indiana.edu/av_test";
		driver = "com.mysql.jdbc.Driver";
		username = "haltay";
		password = "haltay";

		logger.info ("driver   :"+driver);

		logger.info ("url      :"+url);
		logger.info ("username :"+username);
		logger.info ("password :"+password);

		try {
			Class.forName (driver);

			//this.connection = DriverManager.getConnection (url, username, password);

			this.connection = DriverManager.getConnection (url+"?"+"user="+
					 username+"&password="+password+
					 "&autoReconnect=true");

			//("jdbc:mysql://complexity.ucs.indiana.edu/av_test?user=haltay&password=haltay&autoReconnect=true");

			logger.info ("connection success");
		} catch (Exception e) {
			logger.info ("connection fail");
			logger.info (e.toString ());
			logger.info (e.getMessage ());
			e.printStackTrace ();
		}
	}


	public void closeConnection () {
		try {
			if (this.connection!=null) {
				this.connection.close ();
			}
		} catch (Exception e) {
			e.printStackTrace ();
		}
	}


	public Connection getConnection () {
		return connection;
	}
}
