/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab or GlobalMMCS,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *5) Products derived from this software may not be called GlobalMMCS,
 * nor may Indiana University or Community Grids Lab or GlobalMMCS appear
 * in their name, without prior written permission of ARTI.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */
package cgl.globalmmcs.webserver;

import java.util.*;


public class MemberBean {
	private String userid;
	private String sessionid;
	private String roomid;
	private String role;
	private Date start_time;
	private Date active_period;
	private int refresh_time;
	private java.util.logging.Logger logger = java.util.logging.Logger.getLogger (this.
			 getClass ().getName ());

	private String roomaddr; // IP addr for the room
	private String tooltype; // the tool that the memeber wants to use

	public MemberBean () {
		this.userid = "";
		this.roomid = "";
		this.role = "";
		this.start_time = new Date (0);
		this.active_period = new Date (0);
		this.refresh_time = 0;

		this.roomaddr = "";
		this.tooltype = "";
	}


	public String getUserid () {
		return this.userid;
	}


	public void setUserid (String userid) {
		this.userid = userid;
	}


	public String getSessionid () {
		return this.sessionid;
	}


	public void setSessionid (String sessionid) {
		this.sessionid = sessionid;
	}


	public String getRoomid () {
		return this.roomid;
	}


	public void setRoomid (String roomid) {
		this.roomid = roomid;
	}


	public String getRole () {
		return this.role;
	}


	public void setRole (String role) {
		this.role = role;
	}


	public Date getStarttime () {
		return this.start_time;
	}


	public void setStarttime (Date st_time) {
		this.start_time = st_time;
	}


	public Date getActiveperiod () {
		return this.active_period;
	}


	public void setActiveperiod (Date activeperiod) {
		this.active_period = activeperiod;
	}


	public int getRefreshtime () {
		return this.refresh_time;
	}


	public void setRefreshtime (int refresh_time) {
		this.refresh_time = refresh_time;
	}


	public void setRoomaddr (String roomaddr) {
		this.roomaddr = roomaddr;
	}


	public String getRoomaddr () {
		return this.roomaddr;
	}


	public void setTooltype (String tooltype) {
		this.tooltype = tooltype;
	}


	public String getTooltype () {
		return this.tooltype;
	}

}
