/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab or GlobalMMCS,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *5) Products derived from this software may not be called GlobalMMCS,
 * nor may Indiana University or Community Grids Lab or GlobalMMCS appear
 * in their name, without prior written permission of ARTI.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */
package cgl.globalmmcs.webserver;

import java.util.*;
import cgl.globalmmcs.webserver.admin.meetingMgt.GetAllSession;


public class MonthOfCalendars {
	Calendar calendar;
	Vector vector;
	Calendar[][] month;
	private java.util.logging.Logger logger = java.util.logging.Logger.getLogger (this.
			 getClass ().getName ());

	public void nextMonth () {
		Calendar c = (Calendar)this.calendar.clone ();
		int month = c.get (Calendar.MONTH);

		if (month==11) {
			c.set (Calendar.MONTH, 0);
			c.set (Calendar.YEAR, c.get (Calendar.YEAR)+1);
		} else {
			c.set (Calendar.MONTH, month+1);
		}
		this.calendar = c;
		this.fillTheVectorOfCalendars ();
	}


	public int getMonth () {
		int i = 0;
		i = this.calendar.get (Calendar.MONTH);
		return i;
	}


	public String getMonthInString () {
		int i = 0;
		String s = "";
		i = this.calendar.get (Calendar.MONTH);

		switch (i) {
			case 0:
				return "January";
			case 1:
				return "February";
			case 2:
				return "March";
			case 3:
				return "April";
			case 4:
				return "May";
			case 5:
				return "June";
			case 6:
				return "July";
			case 7:
				return "August";
			case 8:
				return "September";
			case 9:
				return "October";
			case 10:
				return "November";
			case 11:
				return "December";
		}

		return s;
	}


	public int getYear () {
		int i = 0;
		i = this.calendar.get (Calendar.YEAR);
		return i;
	}


	public void fillTheTableOfCalendars () {
		this.month = new Calendar[7][8];

		int WEEK_OF_MONTH;
		int DAY_OF_WEEK_IN_MONTH;
		int DAY_OF_WEEK;
		Calendar c;

		for (int i = 0; i<this.vector.size (); i++) {
			c = (Calendar)this.vector.get (i);
			DAY_OF_WEEK = c.get (Calendar.DAY_OF_WEEK);
			WEEK_OF_MONTH = c.get (Calendar.WEEK_OF_MONTH);

			this.month[WEEK_OF_MONTH][DAY_OF_WEEK] = (Calendar) c.clone ();
		}
	}


	public String toStringInHTMLTable (String servletName) {
		String s = "";
		int day = 0;
		int i = 1;
		int j = 1;
		int size = -2;

		s += "<table BORDER=3 CELLSPACING=3 CELLPADDING=3>\n";
		s += "<tr> ";
		s += "     <td><font size="+size+">s</td>   ";
		s += "     <td><font size="+size+">m</td>   ";
		s += "     <td><font size="+size+">t</td>   ";
		s += "     <td><font size="+size+">w</td>   ";
		s += "     <td><font size="+size+">t</td>   ";
		s += "     <td><font size="+size+">f</td>   ";
		s += "     <td><font size="+size+">s</td>   ";
		s += "</tr>\n";
		for (i = 1; i<7; i++) {
			s += "<tr>";
			for (j = 1; j<8; j++) {
				s += " <td> <font size="+size+" " ;
				day = 0;
				try {
					day = this.month[i][j].get (Calendar.DAY_OF_MONTH);
				} catch (Exception ex) {
				}

				if (day!=0) {
					Calendar c = (Calendar)this.month[i][j];

					if (this.sessionExist ((Calendar) c.clone ())) {
						long daylong = c.getTimeInMillis ();
						int DAY_OF_MONTH = c.get (Calendar.DAY_OF_MONTH);
						s += "size="+( size+1 )+ " color = \"red\" " + ">"+ "   <a "+  " color = \"red\" " +"  href=\"" + servletName + "?cmd=manage-session&daylong="+
								 daylong+"\">"+
								 DAY_OF_MONTH+"</a>     ";

					} else {
						s +=  " color = \"gray\" "+  ">" + Integer.toString (day);
					}

				} else {
					s +=  ">" + "";
				}

				s += " </font> </td>     ";
			}

			if (day==0) {
				break;
			}

			s += "</tr>";
			s += "\n";
		}
		s += "\n</table>";
		return s;
	}


	private boolean sessionExist (Calendar cal) {
		Calendar c = cal;
		Calendar cal2;

		if (vOfSessionCalendars.size ()==0) {
			return false;
		}

		Iterator itr = this.vOfSessionCalendars.iterator ();
		while (itr.hasNext ()) {
			cal2 = (Calendar) itr.next ();
			if (Utility.isSameDay (c, cal2)==true) {
				return true;
			}
		}

		return false;
	}


	Vector vOfSessionCalendars;

	private void fillVectorOfSesCals () {
		GetAllSession gas = new GetAllSession ("");
		this.vOfSessionCalendars = gas.getAllSessionDatesInVectorOfCalendars ();
	}


	public MonthOfCalendars (Calendar calendar) {
		this.fillVectorOfSesCals ();
		this.calendar = calendar;
		this.fillTheVectorOfCalendars ();
	}


	public void fillTheVectorOfCalendars () {
		vector = new Vector ();
		Calendar c;
		for (int i = 1; i<=this.calendar.getActualMaximum (Calendar.DAY_OF_MONTH);
				   i++) {
			c = (Calendar)this.calendar.clone ();
			c.set (Calendar.DAY_OF_MONTH, i);
			vector.addElement (c);
		}
		this.fillTheTableOfCalendars ();

	}


	public static void main (String[] args) {
		String s = "";
		//
		Date date = new Date (System.currentTimeMillis ());
		Calendar calendar = new GregorianCalendar ();
		calendar.setTime (date);
		//
		MonthOfCalendars m3 = new MonthOfCalendars (calendar);
		s = m3.toStringInHTMLTable ("admin");
	}
}
