/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab or GlobalMMCS,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *5) Products derived from this software may not be called GlobalMMCS,
 * nor may Indiana University or Community Grids Lab or GlobalMMCS appear
 * in their name, without prior written permission of ARTI.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */
package cgl.globalmmcs.webserver;

import cgl.globalmmcs.webserver.sscomm.SessionMediaDescription;
import cgl.globalmmcs.webserver.sscomm.MediaDescription;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author: Wenjun Wu
 * @version 1.0
 */
public class RoomBean {
	private String roomid;
	private String communityid;
	private String roomname;
	private String roomaddr; // now actually roomaddr is for media description
	private String roomtype;
	private String roomstatus;
	private java.util.logging.Logger logger = java.util.logging.Logger.getLogger (this.
			 getClass ().getName ());

	private String cururl;

	private SessionMediaDescription roomMDes;

	public RoomBean () {
		this.roomid = "";
		this.roomname = "";
		this.communityid = "";
		this.roomaddr = "";
		this.roomtype = "";
		this.roomstatus = "";
		this.roomMDes = new SessionMediaDescription ();
	}


	public void setRoomid (String roomid) {
		this.roomid = roomid;
	}


	public String getRoomid () {
		return this.roomid;
	}


	public void setCommunityid (String communityid) {
		this.communityid = communityid;
	}


	public String getCommunityid () {
		return this.communityid;
	}


	public void setRoomname (String roomname) {
		this.roomname = roomname;
	}


	public String getRoomname () {
		return this.roomname;
	}


	/**
	 * when we set RoomAddr, reset roomMDes
	 */
	public void setRoomaddr (String roomaddr) {
		this.roomaddr = roomaddr;
		// update roomMDes, assume parsing will succeed
		// what about roomMDes is null??
		if (roomaddr!=null&&roomaddr.length ()>0) {
			this.roomMDes.parseClass (roomaddr);
		}
	}


	public String getRoomaddr () {
		return this.roomaddr;
	}


	public void setRoomtype (String roomtype) {
		this.roomtype = roomtype;
	}


	public String getRoomtype () {
		return this.roomtype;
	}


	public void setRoomstatus (String roomstatus) {
		this.roomstatus = roomstatus;
	}


	public String getRoomstatus () {
		return this.roomstatus;
	}


	public void setUrl (String cururl) {
		this.cururl = cururl;
	}


	public String getHtml () {
		StringBuffer sbuff = new StringBuffer ("");
		sbuff.append ("<A href = \""+this.cururl);
		sbuff.append ("roomid="+this.roomid+"\">"+this.roomname+"</A>");

		return sbuff.toString ();
	}


	///////////////////////////////////////////////
	///// Room Media Attributes
	///////////////////////////////////////////////
	public SessionMediaDescription getSessMDes () {
		return (this.roomMDes);
	}


	public void setAudioIPAddr (String ipAddr) {

	}


	public String getAudioIPAddr () {
		MediaDescription audioDesc = roomMDes.getAudioDesc ();
		return (audioDesc.getAddr ());
	}


	public void setAudioPort () {

	}


	public String getAudioPort () {
		MediaDescription audioDesc = roomMDes.getAudioDesc ();
		int port = audioDesc.getPort ();
		return ((new Integer (port)).toString ());
	}


	public void setAudioFmt () {

	}


	public String getAudioFmt () {
		MediaDescription audioDesc = roomMDes.getAudioDesc ();
		return (audioDesc.getCodecType ());
	}


	public void setVideoIPAddr () {

	}


	public String getVideoIPAddr () {
		MediaDescription videoDesc = roomMDes.getVideoDesc ();
		return (videoDesc.getAddr ());
	}


	public void setVideoPort () {

	}


	public String getVideoPort () {
		MediaDescription videoDesc = roomMDes.getVideoDesc ();
		int port = videoDesc.getPort ();
		return ((new Integer (port)).toString ());
	}


	public void setVideoFmt () {

	}


	public String getVideoFmt () {
		MediaDescription videoDesc = roomMDes.getVideoDesc ();
		return (videoDesc.getCodecType ());
	}

}