/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab or GlobalMMCS,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *5) Products derived from this software may not be called GlobalMMCS,
 * nor may Indiana University or Community Grids Lab or GlobalMMCS appear
 * in their name, without prior written permission of ARTI.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */
package cgl.globalmmcs.webserver;

import java.io.*;
import java.net.*;
import java.util.*;

import cgl.globalmmcs.webserver.sscomm.*;


/**
 * @deprecated: it is an old implmentation of the communication channel between
 * web server and A/V session server.
 * it is based on pure TCP rather than NaradaBroker
 * the new implmentation is in sscomm.AdminServerChannel
 */
public class SessionServerChannel {
	private java.util.logging.Logger logger = java.util.logging.Logger.getLogger (this.
			 getClass ().getName ());

	private static SessionServerChannel instance;
	private Socket conn_ss;
	private BufferedReader in;
	private PrintWriter out;
	private xml_msg xmlMsg;
	public static SessionServerChannel getInstance () {
		if (instance==null) {
			instance = new SessionServerChannel ();

		}
		return instance;
	}


	private SessionServerChannel () {
		xmlMsg = new xml_msg ();
		XGSPConfiguration xgsp_conf = XGSPConfiguration.getInstance ();
		String sess_srv_addr = xgsp_conf.getSessionSv ();
		// make connection to session server
		try {
			System.out.println ("Session Channel connected with "+sess_srv_addr);
			if (sess_srv_addr==null) {
				conn_ss = new Socket ("156.56.104.17", 11002);
			} else {
				conn_ss = new Socket (sess_srv_addr, 11002);
				//conn_ss = new Socket("156.56.104.17", 11002 );
			}
			in = new BufferedReader (new InputStreamReader (conn_ss.getInputStream ()));
			out = new PrintWriter (conn_ss.getOutputStream (), true);
		} catch (IOException e) {
			System.out.println ("hate");
		}
	}


	public synchronized boolean ChooseVideoSrc (StreamBean videoSrc,
									    String clientID,
									    String sessionID) {
		// send request xml for choose video src
		XMLGenerator XMLGen = new XMLGenerator ();
		XMLGen.setChooseVideoSrcXML (videoSrc, clientID, sessionID);
		String chooseVideoSrcMsg = XMLGen.getChooseVideoSrcXML ();
		//xmlMsg.set_xml_msg(chooseVideoSrcMsg);
		//System.out.println("Msg to SS for VideoSwitch"+xmlMsg.get_xml_msg());
		try {
			//xmlMsg.send_xml_msg(conn_ss.getOutputStream());
			return true;
		} catch (Exception ex) {
			ex.printStackTrace ();
			return false;
		}
	}


	public synchronized boolean ChooseAudioSrc (Vector audioSrc,
									    String clientID,
									    String sessionID) {
		// send request xml for choose audio src
		XMLGenerator XMLGen = new XMLGenerator ();
		XMLGen.setAudioExclusionListXML (audioSrc, clientID, sessionID);
		String audioExclusionListMsg = XMLGen.getAudioExclusionListXML ();
		//xmlMsg.set_xml_msg(audioExclusionListMsg);
		try {
			//xmlMsg.send_xml_msg(conn_ss.getOutputStream());
			return true;
		} catch (Exception ex) {
			ex.printStackTrace ();
			return false;
		}
	}

}