package cgl.globalmmcs.webserver.admin;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import cgl.globalmmcs.webserver.*;
import cgl.globalmmcs.webserver.websrv.*;
import org.apache.axis.AxisFault;
import cgl.globalmmcs.webserver.sessionmgt.*;


/** This command is used by Administrator to establish an active session
 ** if in the session there are multiple rooms from different communities, then
 ** you have to attach them together
 **/
public class LinkSession implements Command {
	private String next;

	public LinkSession (String next) {
		this.next = next;
	}


	public String execute (HttpServletRequest req) throws CommandException {
		String res;
		try {
			// Get the configuration info, we need H323(SIP)GW calling address
			XGSPConfiguration xgsp_conf = XGSPConfiguration.getInstance ();
			// Get the room list from the session information
			String sess_id = (String) req.getParameter ("sessionid");

			if (sess_id==null) { // no session is selected
				return next;
			}
			//SessionActiveList sess_list = SessionActiveList.getInstance();
			//ActiveSession sess = sess_list.getSession(sess_id);

			XGSPAVSessionManager manager = XGSPAVSessionManager.getInstance ();
			ActiveSession sess = manager.getActiveSession (sess_id);

			SessionBean sess_info = sess.get_sessioninfo ();
			String sess_rooms = sess_info.getSessionplace ();
			// split the sess_rooms into room array;
			java.util.StringTokenizer st = new java.util.StringTokenizer (sess_rooms,
					 ";");
			while (st.hasMoreTokens ()) {
				String tmp = st.nextToken ();
				// tmp format: [ commid:roomid ]
				int split_point = tmp.indexOf (':');
				String commid = tmp.substring (0, split_point);
				String roomid = tmp.substring (split_point+1);
				// For H323room and Siproom, they have to make call to XGSP-Gateway and connect
				// with XGSP-MCU
				// Right now, Only support H323

				CommunityRepository Comms = CommunityRepository.getInstance ();
				CommunityBean community = Comms.getCommunity (commid);
				//RoomBean room = null;
				// get the Class of the CommunityStub
				// service url
				String comm_type = community.getCommunitytype ();
				if (comm_type.equals ("h323")) {
					String comm_service_url = community.getCommunityaddr ();
					String comm_service_entry = "CommunityServer";
					String comm_service_class = "";
					CommunityStub community_service = new CommunityStub (comm_service_url,
							 comm_service_entry, comm_service_class);
					// get the calling address of the target MCU

					String xgsp_mcu_addr = xgsp_conf.getH323GW ();

					//try {
					res = community_service.MakeCall (xgsp_mcu_addr);
					//} catch (org.apache.axis.AxisFault fe) {

					//throw new CommandException("Edit Session Command: " + fe.getMessage());
					//}
					System.out.println ("web service result: "+res);
				}
			}
		} catch (CommRepositoryException fe) {
			throw new CommandException ("Link Session Command: "+fe.getMessage ());
		} catch (Exception qq) {
			qq.printStackTrace ();
		}

		// return the successful result!!1
		return next;
	}
}