/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab or GlobalMMCS,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *5) Products derived from this software may not be called GlobalMMCS,
 * nor may Indiana University or Community Grids Lab or GlobalMMCS appear
 * in their name, without prior written permission of ARTI.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */
package cgl.globalmmcs.webserver.admin.meetingMgt;

/**
 * <p>Title: ModifyVideoMixer </p>
 * <p>Description: this class is a sevelet implementation : modify the existing setting of the video mixer
 * input parameter: sessionID, mixerID, new StreamList
 * </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Community Grids Lab, Indiana University </p>
 * @author : Wenjun Wu
 * @version 1.0
 */
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import cgl.globalmmcs.webserver.*;
import cgl.globalmmcs.webserver.sessionmgt.*;


public class ModVideoMixer implements Command {
	private String next;

	public ModVideoMixer (String next) {
		this.next = next;
	}


	public String execute (HttpServletRequest req) {
		// input parameter: sessionID, mixerID, new StreamList
		String sessionID = req.getParameter ("sessionid"); // sessionid should not be null
		String mixerID = req.getParameter ("mixerid"); // mixerid can be null

		String[] tmpvideo_src = req.getParameterValues ("videosrc");

		XGSPAVSessionManager manager = XGSPAVSessionManager.getInstance ();
		ActiveSession tmpSess = manager.getActiveSession (sessionID);

		Vector newVideoSrc = new Vector ();
		// get the streamBean object and put it into the vector
		if (tmpvideo_src!=null&mixerID!=null) {
			for (int i = 0; i<tmpvideo_src.length; i++) {
				StreamBean newStrm = tmpSess.getStream (tmpvideo_src[i]);
				newVideoSrc.add (newStrm);
			}
			// modify the old mixerID
			manager.ModifyMixer (sessionID, mixerID, newVideoSrc);
		}
		VideoMixer[] mixerList = tmpSess.getAllMixer ();
		req.setAttribute ("mixers", mixerList);
		req.setAttribute ("sessionID", sessionID);
		return next;
	}
}