/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab or GlobalMMCS,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *5) Products derived from this software may not be called GlobalMMCS,
 * nor may Indiana University or Community Grids Lab or GlobalMMCS appear
 * in their name, without prior written permission of ARTI.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */
package cgl.globalmmcs.webserver.admin.meetingMgt;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import cgl.globalmmcs.webserver.*;
import cgl.globalmmcs.webserver.sessionmgt.*;


/** This command is used by Administrator to monitor an active session **/
/** in fact, it is only used for managing mixer **/
public class MonActiveSess implements Command {
	private String next;

	public MonActiveSess (String next) {
		this.next = next;
	}


	public String execute (HttpServletRequest req) {

		String sess_id = req.getParameter ("sessionid");

		XGSPAVSessionManager manager = XGSPAVSessionManager.getInstance ();
		ActiveSession sess = manager.getActiveSession (sess_id);

		//SessionActiveList sess_list = SessionActiveList.getInstance();
		//ActiveSession sess = sess_list.getSession(sess_id);

		String[] tmpvideo_src = req.getParameterValues ("videosrc");

		// check the validility of the ActiveSession, if expired, then return
		if (sess==null) {
			return next;
		}
		//String [] oldvideo_src = sess.GetMixStream();
		String[] oldvideo_src = null;
		// compare it to the old choice, to see whether we need to send video-mixing command
		boolean new_flag = false;
		if (tmpvideo_src==null) {
			tmpvideo_src = oldvideo_src;
		} else {
			if (sess.CompareSelSrc (tmpvideo_src, oldvideo_src)) { // new mixed video choice
				// send the mixed stream request to session server
				sess.SetMixStream (tmpvideo_src);

				//AdminServerChannel conn_ss = AdminServerChannel.getInstance();
				// change the tmpvideo_src into Vector
				Vector new_mixed_video = new Vector ();
				for (int i = 0; i<tmpvideo_src.length; i++) {
					StreamBean tmp_video_bean = sess.getStream (tmpvideo_src[i]);
					new_mixed_video.addElement (tmp_video_bean);
				}
				String session_id = sess_id; // right now no difference
				//conn_ss.SetVideoMix( new_mixed_video, session_id );

			}
		}

		/** set the session information **/
		req.setAttribute ("sessionid", sess_id);
		//req.setAttribute("roomid", room_id );

		/** set the membership information **/

		req.setAttribute ("members", sess.getMembers ());

		/** set the stream information **/
		req.setAttribute ("streams", sess.GetStreamList ());

		// set the checked video src
		if (tmpvideo_src!=null) {
			Vector checked_videosrc = new Vector (tmpvideo_src.length);
			for (int i = 0; i<tmpvideo_src.length; i++) {
				checked_videosrc.add (tmpvideo_src[i]);
			}
			req.setAttribute ("checked_videosrc", checked_videosrc);
		}

		return next;
	}
}