/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab or GlobalMMCS,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *5) Products derived from this software may not be called GlobalMMCS,
 * nor may Indiana University or Community Grids Lab or GlobalMMCS appear
 * in their name, without prior written permission of ARTI.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */
package cgl.globalmmcs.webserver;

import java.lang.*;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.*;


public class htmlcalendarBean {
	private java.util.logging.Logger logger = java.util.logging.Logger.getLogger (this.
			 getClass ().getName ());

	public static final int MONDAY_FIRST = 1; //ÿһΪһ
	public static final int SUNDAY_FIRST = 2; //ÿΪһ
	private Hashtable config;
	private static final String Mnth[] = {
								  "һ", "", "", "", "", "",
								  "", "", "", "ʮ", "ʮһ", "ʮ"
	};
	private static final String Week[] = {
								  "Sun", "Mon", "Tue", "Wen", "Thu", "Fri", "Sat"
	};
	private int year;
	private int month;
	private int style;

	private String sFont;
	private Locale loc;
	private static String NEWLINE = "\n";
	public htmlcalendarBean () {
		sFont = null;
		GregorianCalendar gCalendar = new GregorianCalendar (); //ȡõǰ
		config = new Hashtable (); //µĹϣϢ
		NEWLINE = System.getProperty ("line.separator");
		style = 2; //ÿΪһ
		//month = gCalendar.get(2); //ȡ· year = gCalendar.get(1); //ȡ
		loc = Locale.PRC; //ùĬΪл񹲺͹
	}


	private String formatObject (String s, Object obj) {
		String s1 = "";
		if (obj!=null) {
			s1 = String.valueOf (String.valueOf (obj));
		}
		if (s==null) {
			return s1;
		} else {
			return s+s1+"/font";
		}
	}


	private int getDay (Calendar calendar) { //ȡĳеλ
		if (style==2) {
			return calendar.get (7)-1;
		} else {
			return (calendar.get (7)+5)%7;
		}
	}


	public Locale getLocale () { //ȡ
		return loc;
	}


	public int getYear () {
		return year;
	}


	public int getMonth () {
		return month;
	}


	public int getStyle () {
		return style;
	}


	public void setLocale (Locale locale) {
		loc = locale;
	}


	public void setYear (int htmlCalendarYear) {
		if (htmlCalendarYear>0) {
			year = htmlCalendarYear;
			config.clear ();
		}
	}


	public void setMonth (int htmlCalendarMonth) {
		if (htmlCalendarMonth>=1&&htmlCalendarMonth<=12) {
			month = htmlCalendarMonth;
			config.clear ();
		}
	}


//ʽ
	public void setStyle (int htmlCalendarStyle) {
		style = htmlCalendarStyle;
	}


	private String stringDate (Calendar calendar) {
		String strDay = String.valueOf (calendar.get (1));
		//return strDay + twoDigits(calendar.get(2) + 1) + twoDigits(calendar.get(5));
		return Long.toString (calendar.getTime ().getTime ());
	}


	private String twoDigits (int day) { //Ϊܹ룬1-9 ǰ0
		String stringDay = String.valueOf (day); //ȡdayֵ
		if (stringDay.length ()==1) { //ַΪ1
			return "0"+stringDay; //ַǰ
		} else {
			return stringDay;
		}
	}


	//öURItarget_frame ֵΪ_blank _parent _top _self
	public void setAction (int day, String actionUri, String target_frame) {
		if (actionUri!=null) {
			config.put (String.valueOf (day), actionUri);
			if (target_frame!=null&&target_frame.length ()>0) {
				config.put (day+"target", target_frame);
			}
		}
	}


	//һµĳ
	public void setActions (String actionUri, String target_frame) {
		for (int day = 1; day<=31; day++) {
			setAction (day, actionUri, target_frame);
		}
	}


	public String getHtml () {
		GregorianCalendar gCalendar = new GregorianCalendar (year, month-1, 1);
		GregorianCalendar gCalendar1 = new GregorianCalendar (2002, 8, 5);
		SimpleDateFormat simpledateformat = new SimpleDateFormat ("EEE", loc);
		//дʽEEEڵд Sun, EEEEΪSunday
		int i = month-1;
		int j = 0;
		StringBuffer stringbuffer = new StringBuffer (""); //µַ
		stringbuffer.append ("<table><tr>\n"); //stringbufferӡtabletrΪ׼
		if (style==2) { //Ͻ
			//stringbuffer.append("<th align=right>" + formatObject(sFont, simpledateformat.format(gCalendar1.getTime())) + "</th>\n");
			//gCalendar1.add(5, 1);
			for (int k = 1; k<=7; k++) {
				//stringbuffer.append("<th align=right>" + formatObject(sFont,simpledateformat.format(gCalendar1.getTime())) + "</th>\n");
				stringbuffer.append ("<th align=right>"+formatObject (sFont, Week[k-1])+
								 "</th>\n");
				gCalendar1.add (5, 1);
			}
		} else {
			//gCalendar1.add(5, 1);
			stringbuffer.append ("<th align=right>"+
							 formatObject (sFont,
										simpledateformat.format (gCalendar1.
					 getTime ()))+"</th>\n");
			for (int l = 2; l<8; l++) {
				gCalendar1.add (5, 1);
				stringbuffer.append ("<th align=right>"+
								 formatObject (sFont,
						 simpledateformat.format (gCalendar1.
						 getTime ()))+"</th>\n");
			}
		}
		stringbuffer.append ("</tr>\n");

		int i1 = 0;
		j = 0;
		if (getDay (gCalendar)>0) {
			stringbuffer.append ("<tr>");
			for (; i1<getDay (gCalendar); i1++) {
				stringbuffer.append ("<td align=right>");
				if (sFont!=null) {
					stringbuffer.append (sFont+" </font>");
				} else {
					stringbuffer.append (" ");
				}
				stringbuffer.append ("</td>\n");
				j++;
			}
		}
		for (; gCalendar.get (2)==i; gCalendar.add (5, 1)) {
			int j1 = gCalendar.get (5);
			int k1 = (i1+j1)%7;
			if (k1==1) {
				stringbuffer.append ("<tr>"+NEWLINE);
				j = 0;
			}
			stringbuffer.append ("<td align=right>");
			j++;
			if (sFont!=null) {
				stringbuffer.append (sFont);
			}
			String s;
			if ((s = (String) config.get (String.valueOf (j1)))!=null) {
				stringbuffer.append ("<a href=\"");
				if (s.toUpperCase ().startsWith ("HTT")||s.indexOf (".")>0) {
					stringbuffer.append (s);
					if (s.indexOf ("?")<0) {
						stringbuffer.append ("?date="+stringDate (gCalendar));
					} else {
						stringbuffer.append ("&date="+stringDate (gCalendar));
					}
				} else {
					stringbuffer.append ("javascript:"+s+"('"+stringDate (gCalendar)+
									 "');");
				}
				stringbuffer.append ("\"");
				if ((s = (String) config.get (j1+"target"))!=null) {
					stringbuffer.append (" target=\""+s+"\"");
				}
				stringbuffer.append (">");
				int tmp = gCalendar.get (5);
				stringbuffer.append (tmp);
				stringbuffer.append ("</a>\n");
			} else {
				stringbuffer.append (String.valueOf (j1));
			}
			if (sFont!=null) {
				stringbuffer.append ("</font>");
			}
			stringbuffer.append ("</td>\n");
			if (k1==0) {
				stringbuffer.append ("</tr>\n");
			}
		}
		if (j<7) {
			for (; j<7; j++) {
				stringbuffer.append ("<td align=right>");
				if (sFont!=null) {
					stringbuffer.append (sFont);
				}
				stringbuffer.append (" ");
				if (sFont!=null) {
					stringbuffer.append ("</font>");
				}
				stringbuffer.append ("</td>\n");
			}
			stringbuffer.append ("</tr>\n");
		}
		stringbuffer.append ("</table>\n");
		return stringbuffer.toString ();
	}
}
