/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab or GlobalMMCS,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *5) Products derived from this software may not be called GlobalMMCS,
 * nor may Indiana University or Community Grids Lab or GlobalMMCS appear
 * in their name, without prior written permission of ARTI.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */
package cgl.globalmmcs.webserver.sscomm;

import org.jdom.*;
import java.util.*;


public class ReplyUserList extends XMLMessage {
	private String UserID;
	private String ConfID;
	private UserList userList;

	public ReplyUserList () {
	}


	public void setUserID (String userID) {
		this.UserID = userID;
	}


	public String getUserID () {
		return this.UserID;
	}


	public void setConfID (String confID) {
		this.ConfID = confID;
	}


	public String getConfID () {
		return this.ConfID;
	}


	public void setUserList (UserList confUsers) {
		this.userList = confUsers;
	}


	public UserList getUserList () {
		return this.userList;
	}


	public Object parseClass (Element e) {
		Iterator it = e.getChildren ().iterator ();
		while (it.hasNext ()) {
			Element et = (Element) it.next ();
			if (et.getName ().equalsIgnoreCase ("UserID")) {
				this.UserID = et.getTextTrim ();
			} else if (et.getName ().equalsIgnoreCase ("ConferenceID")) {
				this.ConfID = et.getTextTrim ();
			} else if (et.getName ().equalsIgnoreCase ("UserList")) {
				this.userList = new UserList ();
				userList.parseClass (et);
			}
		}
		return this;
	}


	public Object cloneClass (XMLMessage obj) {
		ReplyUserList org = (ReplyUserList) obj;
		this.UserID = org.getUserID ();
		this.ConfID = org.getConfID ();
		this.userList = org.getUserList ();

		return this;
	}


	public String toXML (String delimit) {
		String xml = "";
		xml += "<ReplyUserList>";
		xml += "<UserID>"+this.UserID+"</UserID>";
		xml += "<ConferenceID>"+this.ConfID+"</ConferenceID>";
		xml += userList.toXML (delimit);
		xml += "</ReplyUserList>";

		return xml;
	}
}