/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab or GlobalMMCS,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *5) Products derived from this software may not be called GlobalMMCS,
 * nor may Indiana University or Community Grids Lab or GlobalMMCS appear
 * in their name, without prior written permission of ARTI.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */
package cgl.globalmmcs.webserver.sscomm;

import org.jdom.*;

import java.util.*;


public class SessionReport {

	private String SessionID;
	private int CurParticipantNum;
	private int PastParticipantNum;

	public SessionReport () {
	}


	public void setSessionID (String SessionID) {
		this.SessionID = SessionID;
	}


	public void setCurPart (String CurMembers) {

		this.CurParticipantNum = (new Integer (CurMembers)).intValue ();
	}


	public void setPastPart (String PastMembers) {
		this.PastParticipantNum = (new Integer (PastMembers)).intValue ();
	}


	public String getSessionID () {
		return (this.SessionID);
	}


	public int getCurPart () {
		return (this.CurParticipantNum);
	}


	public int getPastPart () {
		return (this.PastParticipantNum);
	}


	/**
	 * parse the object
	 * SessionReport -- SessionID, SessionStatusInfo ( CurParticipant, PastParticipant )
	 */
	public Object parseClass (Element e) {
		Iterator it = e.getChildren ().iterator ();
		while (it.hasNext ()) {
			Element et = (Element) it.next ();
			if (et.getName ().equalsIgnoreCase ("SessionID")) { // get SessionID
				SessionID = et.getTextTrim ();
			} else if (et.getName ().equalsIgnoreCase ("SessionStatusInfo")) {
				Iterator it2 = et.getChildren ().iterator ();
				while (it2.hasNext ()) {
					Element et2 = (Element) it2.next ();
					if (et2.getName ().equalsIgnoreCase ("CurParticipant")) {
						CurParticipantNum = Integer.parseInt (et2.getTextTrim ());
					} else if (et2.getName ().equalsIgnoreCase ("PastParticipant")) {
						PastParticipantNum = Integer.parseInt (et2.getTextTrim ());
					}
				}
			}
		}
		return this;
	}


	public String toXML (String delimiter) {
		String sessionreport = "";
		sessionreport += "<SessionReport>";
		sessionreport += delimiter;
		sessionreport += ("<SessionID>"+SessionID+"</SessionID>");
		sessionreport += delimiter;
		sessionreport += "<SessionStatusInfo>";
		sessionreport += delimiter;
		sessionreport +=
				 ("<CurParticipant>"+CurParticipantNum+"</CurParticipant>");
		sessionreport = delimiter;
		sessionreport +=
				 ("<PastParticipant>"+PastParticipantNum+"</PastParticipant>");
		sessionreport = delimiter;
		sessionreport += "</SessionReport>";
		return sessionreport;
	}

}