/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab or GlobalMMCS,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *5) Products derived from this software may not be called GlobalMMCS,
 * nor may Indiana University or Community Grids Lab or GlobalMMCS appear
 * in their name, without prior written permission of ARTI.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */
package cgl.globalmmcs.webserver.sscomm;

import org.jdom.*;
import java.util.*;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class UpdateSessionInfo extends XMLMessage {
	private String action = "NewSession"; // NewSession, ByeSession, UnknownAction
	private String communityName = "";
	private String communityType = "";
	private String roomID = "";
	private String sessionID = "";

	private SessionMediaDescription sessionMediaDes;

	public UpdateSessionInfo () {
		this.msgType = "SessionInformation";
	}


	public UpdateSessionInfo (String action, String communityName,
						 String communityType,
						 String roomID, String sessionID) {
		this.msgType = "SessionInformation";

		this.action = action;
		this.communityName = communityName;
		this.communityType = communityType;
		this.roomID = roomID;
		this.sessionID = sessionID;
	}


	public void setSessionMediaDescription (SessionMediaDescription
									sessionMediaDescription) {
		this.sessionMediaDes = sessionMediaDescription;
	}


	public SessionMediaDescription getSessionMediaDes () {
		return (this.sessionMediaDes);
	}


	/**
	 * @param action DOCUMENT ME!
	 */
	public void setAction (String action) {
		this.action = action;
	}


	/**
	 * @return DOCUMENT ME!
	 */
	public String getAction () {
		return action;
	}


	public void setCommunityName (String communityName) {
		this.communityName = communityName;
	}


	/**
	 * @return DOCUMENT ME!
	 */
	public String getCommunityName () {
		return communityName;
	}


	public void setCommunityType (String communityType) {
		this.communityType = communityType;
	}


	/**
	 * @return DOCUMENT ME!
	 */
	public String getCommunityType () {
		return communityType;
	}


	public void setRoomID (String roomID) {
		this.roomID = roomID;
	}


	/**
	 * DOCUMENT ME!
	 * @return DOCUMENT ME!
	 */
	public String getRoomID () {
		return roomID;
	}


	public String getSessionID () {
		return (this.sessionID);
	}


	public Object parseClass (Element e) {
		this.msgType = "SessionInformation";
		try {
			Iterator it = e.getChildren ().iterator ();
			while (it.hasNext ()) {
				e = (Element) it.next ();
				if (e.getName ().equalsIgnoreCase ("Action")) {
					action = e.getTextTrim ();
					if (!(action.equalsIgnoreCase ("NewSession"))||
					    !(action.equalsIgnoreCase ("ByeSession"))) {
						action = "UnknownAction";
					}
				} else if (e.getName ().equalsIgnoreCase ("CommunityType")) {
					communityType = e.getTextTrim ();
				} else if (e.getName ().equalsIgnoreCase ("CommunityName")) {
					communityName = e.getTextTrim ();
				} else if (e.getName ().equalsIgnoreCase ("RoomID")) {
					roomID = e.getTextTrim ();
				} else if (e.getName ().equalsIgnoreCase ("SessionMediaDescription")) {
					sessionMediaDes.parseClass (e);
					sessionID = sessionMediaDes.getSessionID ();
				}
			}
		} catch (Exception ex) {
		}
		return this;
	}


	public Object cloneClass (XMLMessage obj) {
		this.msgType = "SessionInformation";
		communityType = ((UpdateSessionInfo) obj).getCommunityType ();
		communityName = ((UpdateSessionInfo) obj).getCommunityName ();
		roomID = ((UpdateSessionInfo) obj).getRoomID ();
		sessionMediaDes.cloneClass (((UpdateSessionInfo) obj).getSessionMediaDes ());
		sessionID = ((UpdateSessionInfo) obj).getSessionID ();
		action = ((UpdateSessionInfo) obj).getAction ();
		return this;
	}


	/**
	 *
	 */
	public String toXML (String delimiter) {
		String sessioninformation = "";
		sessioninformation += "<SessionInformation>";
		sessioninformation += delimiter;
		sessioninformation +=
				 ("  <CommunityType>"+communityType+"</CommunityType>");
		sessioninformation += delimiter;
		sessioninformation +=
				 ("  <CommunityName>"+communityName+"</CommunityName>");
		sessioninformation += delimiter;
		sessioninformation += ("  <RoomID>"+roomID+"</RoomID>");
		sessioninformation += delimiter;
		sessioninformation += ("  <Action>"+action+"</Action>");
		sessioninformation += delimiter;
		sessioninformation += sessionMediaDes.toXML (delimiter+"  ");
		sessioninformation += delimiter;
		sessioninformation += "</SessionInformation>";
		return sessioninformation;
	}
}