/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab or GlobalMMCS,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *5) Products derived from this software may not be called GlobalMMCS,
 * nor may Indiana University or Community Grids Lab or GlobalMMCS appear
 * in their name, without prior written permission of ARTI.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */
package cgl.globalmmcs.webserver.sscomm;

import java.util.*;
import cgl.globalmmcs.webserver.*;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class XMLGenerator {
	private String xmlMsg;
	private String sessionID;
	private String sessionInfoXML;
	private String clientListRequestXML;
	private String mediaRequestXML;
	private String chooseVideoSrcXML;
	private String audioExclusionListXML;
	private String avClientListXML;
	private String videoMixXML;
	private String activeSessionXML;

	public XMLGenerator () {
		xmlMsg = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
	}


	public XMLGenerator (String sessionID) {
		this.xmlMsg = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
		this.sessionID = sessionID;
	}


	public void setSessionID (String sessionID) {
		this.sessionID = sessionID;
	}


	public String getSessionID () {
		return sessionID;
	}


	/**************************************************************************/
	public void setSessionInfoXML () {
		sessionInfoXML = xmlMsg;
		sessionInfoXML += "<WebInterface>";
		sessionInfoXML += "<SessionID>"+sessionID+"</SessionID>";
		sessionInfoXML += "</WebInterface>";
	}


	public void setSessionInfoXML (String sessionID) {
		sessionInfoXML = "<WebInterface>";
		sessionInfoXML += "<SessionID>"+sessionID+"</SessionID>";
		sessionInfoXML += "</WebInterface>";
	}


	public String getSessionInfoXML () {
		return sessionInfoXML;
	}


	/**************************************************************************/
	public void setClientListRequestXML () {
		clientListRequestXML = xmlMsg;
		clientListRequestXML += "<WebInterface>";
		clientListRequestXML += "<ClientListRequest>";
		clientListRequestXML += "<SessionID>"+sessionID+"</SessionID>";
		clientListRequestXML += "</ClientListRequest>";
		clientListRequestXML += "</WebInterface>";
	}


	public String getClientListRequestXML () {
		return clientListRequestXML;
	}


	/**************************************************************************/
	public void setMediaRequestXML (String clientID, Vector vec1, Vector vec2) {
		mediaRequestXML = xmlMsg;
		mediaRequestXML += "<WebInterface>";
		mediaRequestXML += "<MediaRequest>";
		mediaRequestXML += "<SessionID>"+sessionID+"</SessionID>";
		mediaRequestXML += "<clientID>"+clientID+"</clientID>";
		mediaRequestXML += "<AudioList>";
		int i = 0;
		for (i = 0; i<vec1.size (); i++) {
			mediaRequestXML += "<clientID>"+(String) vec1.elementAt (i)+
					 "</clientID>";
		}
		mediaRequestXML += "</AudioList>";
		mediaRequestXML += "<VideoList>";
		for (i = 0; i<vec2.size (); i++) {
			mediaRequestXML += "<clientID>"+(String) vec2.elementAt (i)+
					 "</clientID>";
		}
		mediaRequestXML += "</VideoList>";
		mediaRequestXML += "</MediaRequest>";
		mediaRequestXML += "</WebInterface>";

	}


	public String getMediaRequestXML () {
		return mediaRequestXML;
	}


	/**************************************************************************/
	public void setChooseVideoSrcXML (StreamBean videoSrc, String clientID,
							    String sessionID) {

		chooseVideoSrcXML = xmlMsg;
		chooseVideoSrcXML += "<ChooseVideoSource>";
		chooseVideoSrcXML += "<SessionID>"+sessionID+"</SessionID>";
		chooseVideoSrcXML += "<ClientID>"+clientID+"</ClientID>";
		chooseVideoSrcXML += "<MixedVideo>"+videoSrc.getMixed ()+"</MixedVideo>";
		//if(videoSrc.getMixed() == false) {
		chooseVideoSrcXML += "<VideoSource>";
		chooseVideoSrcXML += "<UserName>"+videoSrc.getUsername ()+"</UserName>";
		chooseVideoSrcXML += "<SSRC>"+videoSrc.getSsrc ()+"</SSRC>";
		chooseVideoSrcXML += "<Description>"+videoSrc.getStrdescription ()+
				 "</Description>";
		chooseVideoSrcXML += "</VideoSource>";
		//}
		chooseVideoSrcXML += "</ChooseVideoSource>";
	}


	public String getChooseVideoSrcXML () {
		return chooseVideoSrcXML;
	}


	/**************************************************************************/
	public void setAudioExclusionListXML (Vector audioSrc, String clientID,
								   String sessionID) {
		audioExclusionListXML = xmlMsg;
		audioExclusionListXML += "<AudioExclusionList>";
		audioExclusionListXML += "<SessionID>"+sessionID+"</SessionID>";
		audioExclusionListXML += "<ClientID>"+clientID+"</ClientID>";
		audioExclusionListXML += "<AudioList>";
		for (int i = 0; i<audioSrc.size (); i++) {
			audioExclusionListXML += "<UserName>"+
					 ((StreamBean) audioSrc.elementAt (i)).getUsername ()+"</UserName>";
			audioExclusionListXML += "<SSRC>"+
					 ((StreamBean) audioSrc.elementAt (i)).getSsrc ()+"</SSRC>";
			audioExclusionListXML += "<Description>"+
					 ((StreamBean) audioSrc.elementAt (i)).getStrdescription ()+
					 "</Description>";
		}
		audioExclusionListXML += "</AudioList>";
		audioExclusionListXML += "</AudioExclusionList>";
	}


	public String getAudioExclusionListXML () {
		return chooseVideoSrcXML;
	}


	/**************************************************************************/
	public void setAVClientListXML (String sessionID) {
		avClientListXML = xmlMsg;
		avClientListXML += "<AVClientList>";
		avClientListXML += "<SessionID>"+sessionID+"</SessionID>";
		avClientListXML += "</AVClientList>";
	}


	public String getAVClientListXML () {
		return avClientListXML;
	}


	/**************************************************************************/
	public void setVideoMixXML (Vector videoSrc, String sessionID, String mixerID,
						   boolean active) {
		videoMixXML = xmlMsg;
		videoMixXML += "<VideoMixer>";
		videoMixXML += "<SessionID>"+sessionID+"</SessionID>";
		videoMixXML += "<MixerID>"+mixerID+"</MixerID>";
		videoMixXML += "<Active>"+active+"</Active>";
		videoMixXML += "<Clients>";
		int i = 0;
		for (i = 0; (i<videoSrc.size ()&&i<4); i++) {
			videoMixXML += "<client>";
			videoMixXML += "<UserName>"+((StreamBean) videoSrc.get (i)).getUsername ()+
					 "</UserName>";
			videoMixXML += "<SSRC>"+((StreamBean) videoSrc.get (i)).getSsrc ()+
					 "</SSRC>";
			videoMixXML += "<Description>"+
					 ((StreamBean) videoSrc.get (i)).getStrdescription ()+
					 "</Description>";
			videoMixXML += "</client>";
		}
		videoMixXML += "</Clients>";
		videoMixXML += "</VideoMixer>";
	}


	public String getVideoMixXML () {
		return videoMixXML;
	}


	/**************************************************************************/
	public void setActiveSessionXML (String sessionid, boolean active,
							   Vector roomlist) {
		int roomtype; // 0: ag; 1: h323; 2: sip

		activeSessionXML = xmlMsg;
		activeSessionXML += "<ActiveSession>";
		activeSessionXML += "<SessionID>"+sessionid+"</SessionID>";
		activeSessionXML += "<Active>"+active+"</Active>";
		activeSessionXML += "<Communities>";
		for (int i = 0; i<roomlist.size (); i++) {
			activeSessionXML += "<Community>";
			/** if (((RoomBean)roomlist.get(i)).getRoomtype().equals("AG")) {
			 activeSessionXML += "<AGCommunity>";
			 roomtype = 0;
			 } else if ( ((RoomBean)roomlist.get(i)).getRoomtype().equals("H323") ){
			 activeSessionXML += "<H323Community>";
			 roomtype = 1;
			   } else {
			    activeSessionXML += "<SIPCommunity>";
			    roomtype = 2;
			   } **/
			activeSessionXML += "<CommunityType>"+
					 ((RoomBean) roomlist.get (i)).getRoomtype ()+"</CommunityType>";
			activeSessionXML += "<CommunityName>"+
					 ((RoomBean) roomlist.get (i)).getCommunityid ()+"</CommunityName>";
			activeSessionXML += "<RoomID>"+((RoomBean) roomlist.get (i)).getRoomid ()+
					 "</RoomID>";

			/** if ( roomtype == 0 ) activeSessionXML += "</AGCommunity>";
			 else if ( roomtype == 1 ) activeSessionXML += "</H323Community>";
			 else activeSessionXML += "</SIPCommunity>"; **/

			activeSessionXML += "</Community>";
		}
		activeSessionXML += "</Communities>";
		activeSessionXML += "</ActiveSession>";
	}


	public String getActiveSessionXML () {
		return activeSessionXML;
	}
	/**************************************************************************/
}