/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab or GlobalMMCS,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *5) Products derived from this software may not be called GlobalMMCS,
 * nor may Indiana University or Community Grids Lab or GlobalMMCS appear
 * in their name, without prior written permission of ARTI.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */
package cgl.globalmmcs.webserver.sscomm;

import java.io.*;
import java.util.*;
import cgl.narada.jms.*;
import javax.jms.*;


/**
 * This class is used to send and receive xml messages
 */

public class xml_msg {

	private String msg = "";
//  Constructors
	public xml_msg () {}


	public xml_msg (String _msg) {
		msg = _msg;
	}


//  Send xml message. Needs OutputStream as input
	public void send_xml_msg (TopicSession m_session, TopicPublisher m_publisher,
						 String messageType, String MsgContent) {
		/** try {
		    PrintWriter  out = new PrintWriter(_outStream,true);
		    //message is inserted between <message> and </message> tags
		    String outputMSG = "<message "+msg.length()+">"+msg+"</message>";
		    out.println(outputMSG);
		  } catch(Exception exo) { exo.printStackTrace(); } **/
		try {
			TextMessage msg = (TextMessage) m_session.createTextMessage ();

			msg.setStringProperty ("messagetype", messageType);
			msg.setText (MsgContent);
			m_publisher.publish (msg);
		} catch (Exception e) {
			e.printStackTrace ();
		}

	}


	public String receive_xml_msg (String message) {
		System.out.println ("get XML Message: "+message);
		return (message);
	}
//  Receives xml message. Needs InputStreamReader as input
	/**     public Vector receive_xml_msg(String message_input ) { //?????
	 msg = "";
	 Vector messages = new Vector();
	 try {
	 BufferedReader br = new BufferedReader(_inStreamReader);
	 String line = "";
	 while (!line.trim().endsWith("</message>")) {
	  //System.out.println("Hello");
	  line = br.readLine();
	  msg +=line;
	  msg +="\n";
	 }
	 } catch (Exception exi) { exi.printStackTrace(); }
	 msg = msg.trim();
	 int startIndex = 0;
	 int endIndex = 0;
	 int lastIndex = msg.lastIndexOf("</message>");
	 while (lastIndex > endIndex) {
	 //System.out.println("Hello extracting string");
	 String subMSG = "";
	 startIndex = msg.indexOf("<message ", endIndex);
	 startIndex = msg.indexOf(">", startIndex)+1;
	 endIndex = msg.indexOf("</message>", startIndex);
	 subMSG = msg.substring(startIndex, endIndex);
	 messages.add(subMSG);
	 }
	 return messages;
	    }
	 **/

	//public String get_xml_msg() { return msg; }
	//public void set_xml_msg(String _msg) { msg = _msg; }
}
