/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab or GlobalMMCS,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *5) Products derived from this software may not be called GlobalMMCS,
 * nor may Indiana University or Community Grids Lab or GlobalMMCS appear
 * in their name, without prior written permission of ARTI.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */
package cgl.globalmmcs.webserver.user;

import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import cgl.globalmmcs.webserver.*;


/*
 * Make a registration for the new user
 */
public class RegisterComm implements Command {
	private String next;

	public RegisterComm (String next) {
		this.next = next;
	}


	public String execute (HttpServletRequest req) throws CommandException {
		try {
			UserRepository users = UserRepository.getInstance ();
			UserBean user = new UserBean ();
			// first check userid, if it is a duplicat one, then return(register.jsp)
			user.setUserid (req.getParameter ("userid"));
			user.setPasswd (req.getParameter ("password1"));
			// concate the first name, middle, and the last name
			String first = req.getParameter ("first");
			String middle = req.getParameter ("middle");
			String last = req.getParameter ("last");
			// add a space between firstname and other names
			String username = first+" "+middle+last;
			user.setUsername (username);
			users.put (user);

			// in the future, a user account needed to be furtherly activated!!

			// Create the session for this user, and add it into activeuserlist
			ActiveUserList userlist = ActiveUserList.getInstance ();
			userlist.add_user (user);
			UserBean[] online_users = userlist.getUsers ();
			HttpSession session = req.getSession (true);
			session.putValue ("user", user);

			req.setAttribute ("user", user);
			req.setAttribute ("users", online_users);

			return next;
		} catch (UserRepositoryException ee) {
			throw new CommandException ("Register Command:"+ee.getMessage ());
		}
	}
}
/*
 package cgl.globalmmcs.webserver;
 import java.util.logging.*;
 import javax.servlet.http.*;
 public class Register implements Command {
  private String next;
  private Logger logger = Logger.getLogger (this.getClass ().getName ());
  public Register (String next) {
   this.next = next;
  }
  public String execute (HttpServletRequest req) throws CommandException {
   try {
    UserRepository users = UserRepository.getInstance ();
    UserBean user = new UserBean ();
    user.setUserid (req.getParameter ("userid"));
    user.setPasswd (req.getParameter ("passwd"));
    String first = req.getParameter ("first");
    String middle = req.getParameter ("middle");
    String last = req.getParameter ("last");
    String username = first+" "+middle+" "+last;
    user.setUsername (username);
    user.setUsertype (req.getParameter ("usertype"));
    user.setEmailaddr (req.getParameter ("emailaddr"));
    user.setTelephone (req.getParameter ("telephone"));
    users.put (user);
    return next;
   } catch (UserRepositoryException e) {
    logger.severe ("Exception : "+this.getClass ().getName ());
    logger.severe ("Exception : "+e.getMessage ());
    logger.severe ("Exception : "+e.toString ());
    e.printStackTrace ();
 throw new CommandException ("Register Command:"+e.getMessage ());
   }
  }
 }
 */