/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab or GlobalMMCS,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *5) Products derived from this software may not be called GlobalMMCS,
 * nor may Indiana University or Community Grids Lab or GlobalMMCS appear
 * in their name, without prior written permission of ARTI.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */
package cgl.globalmmcs.webserver.user;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import cgl.globalmmcs.webserver.*;
import cgl.globalmmcs.webserver.sessionmgt.ActiveSession;


/**
 * enter Room: peridical loop between joinSession.jsp <--> enterRoom.java
 * @deprecated: the old implmentation without XGSPApplet
 */
public class enterRoom implements Command {
	private String next;

	public enterRoom (String next) {
		this.next = next;
	}


	public String execute (HttpServletRequest req)
	//throws CommandException {
	{
		/** a lot of job needed to be done:
		 ** maintain the membership of the session and control the audio/video source choice
		 **/

		// different strategy for different combintation of client and mcu
		// set the attribute for the membership list of the session
		String remoteaddr, client_id, session_id;

		String sess_id = req.getParameter ("sessionid");
		String room_id = req.getParameter ("roomid");
		String tooltype = req.getParameter ("tooltype");

		String deviceAddr = req.getParameter ("deviceAddr");

		SessionActiveList sess_list = SessionActiveList.getInstance ();
		ActiveSession sess = sess_list.getSession (sess_id);
		// get the member of this user
		HttpSession H_sess = req.getSession (false);
		UserBean user = (UserBean) H_sess.getValue ("user");
		String user_id = user.getUserid ();
		MemberBean mem = sess.getMember (user_id);
		String ref_st = req.getParameter ("RefreshTime");
		if (ref_st!=null) { // that means it is not the first time the member enters the room
			int refresh = Integer.parseInt (ref_st);
			mem.setRefreshtime (refresh);
		} else if (mem.getRefreshtime ()<=0) {
			mem.setRefreshtime (100);
			// get room addr from database
			try {
				RoomRepository rooms = RoomRepository.getInstance ();
				RoomBean room = rooms.getRoom (room_id);
				String roomaddr = room.getRoomaddr ();
				mem.setRoomaddr (roomaddr);
				mem.setTooltype (tooltype);
			} catch (Exception ee) {
				mem.setRoomaddr ("156.56.104.1");
			}
		}

		// Create <SessionID, ClientID> for choose-video-src
		// when room is H323 type, then remoteaddr has to be the addr of that room
		// Validate the device addr, if not use the ip addr from the web browser
		if (deviceAddr==null||deviceAddr.length ()==0) {
			remoteaddr = req.getRemoteAddr ();
		} else {
			remoteaddr = deviceAddr;

		}
		if (tooltype==null) {
			tooltype = "H323";
		}
		if (tooltype.equals ("H323")) {
			client_id = "h323@"+remoteaddr;
		} else if (tooltype.equals ("AccessGrid")) {
			client_id = "ag@"+remoteaddr;
		} else {
			client_id = "unkown@"+remoteaddr;

			//session_id = room_id; // right now no difference
		}
		session_id = sess_id;

		// Set the choice of video & audio sources
		SessionServerChannel conn_ss = SessionServerChannel.getInstance ();
		StreamBean old_videosrc = (StreamBean) H_sess.getValue ("videosrc");

		String videosrc_ssrc = req.getParameter ("videosrc");
		if (videosrc_ssrc!=null) { // get the checked video src
			StreamBean new_videosrc = sess.getStream (videosrc_ssrc);
			// get new video src choice
			if (old_videosrc==null||
			    new_videosrc.getSsrc ()!=old_videosrc.getSsrc ()) {
				H_sess.putValue ("videosrc", new_videosrc);
				// send the choosed video src to the session server
				// check the username of this stream, and decide whether to set mixed stream flag
				if ((new_videosrc.getUsername ()).equals ("MixedVideo")) {
					new_videosrc.setMixed (true);
				}
				//remoteaddr = req.getRemoteAddr();
				//client_id =  "h323@"+remoteaddr;
				//session_id = room_id; // right now no difference
				conn_ss.ChooseVideoSrc (new_videosrc, client_id, session_id);
			}
		}
		// set the audio choice
		String[] old_audiosrc = (String[]) H_sess.getValue ("audiosrc");
		String[] new_audiosrc = req.getParameterValues ("audiosrc"); // get the list of audio src choice
		boolean new_flag = sess.CompareSelSrc (new_audiosrc, old_audiosrc);
		// if new flag, then send audio
		if (new_flag) {
			H_sess.putValue ("audiosrc", new_audiosrc);
			//remoteaddr = req.getRemoteAddr();
			//client_id =  "h323@"+remoteaddr;
			//session_id = room_id; // right now no difference
			// create audio src bean and send the request to the session server
			//conn_ss.ChooseAudioSrc( new_audiosrc, client_id, session_id );
		}
		// set these attributions for the next cycle of enter-room
		// enterRoom --> SessionWork --> enterRoom --> ...
		req.setAttribute ("sessionid", sess_id);
		req.setAttribute ("roomid", room_id);
		req.setAttribute ("tooltype", tooltype);
		req.setAttribute ("deviceAddr", deviceAddr);

		req.setAttribute ("me", mem);
		req.setAttribute ("members", sess.getMembers ());
		// set the attribute for the refreshing time

		// set the attribute for A/V stream list
		req.setAttribute ("streams", sess.GetStreamList ());

		// set the checked video src and audio src
		String[] checked_audiobean = (String[]) H_sess.getValue ("audiosrc");
		if (checked_audiobean!=null) { // create a vector for these ssrc
			Vector checked_audiosrc = new Vector (checked_audiobean.length);
			for (int i = 0; i<checked_audiobean.length; i++) {
				checked_audiosrc.add (checked_audiobean[i]);
			}
			req.setAttribute ("checked_audiosrc", checked_audiosrc);
		}

		StreamBean checked_videosrc = (StreamBean) H_sess.getValue ("videosrc");
		if (checked_videosrc!=null) {
			req.setAttribute ("checked_videosrc", checked_videosrc.getSsrc ());

		}
		return next;
	}
}