/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab or GlobalMMCS,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *5) Products derived from this software may not be called GlobalMMCS,
 * nor may Indiana University or Community Grids Lab or GlobalMMCS appear
 * in their name, without prior written permission of ARTI.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */
package cgl.globalmmcs.webserver.websrv;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.net.*; // Socket

import cgl.globalmmcs.webserver.*;


/*
 * @deprecated: the test of web service for H.323
 */
public class CommunityService {

//public  Communityinfo getRoomList()
	public RoomBean[] getRoomList ()
//public String getRoomList()
			 throws CommandException {
		try {
			RoomRepository rooms = RoomRepository.getInstance ();
			RoomBean[] roomList = rooms.getRooms ();
			/** RoomBean aroom = new RoomBean();
			  aroom.setRoomid("xx");
			  aroom.setCommunityid("xx");
			  aroom.setRoomname("xx");
			  aroom.setRoomtype("xx");
			  aroom.setRoomaddr("xx");
			  RoomBean[] roomList = new RoomBean[] { aroom }; **/

			Communityinfo comm = new Communityinfo ();
			comm.setRoomlist (roomList);
			//return comm;
			return roomList;
			//return "I hate the world!";
		} catch (RoomRepositoryException ce) {
			throw new CommandException ("Get Room command:"+ce.getMessage ());
		}

	}


	//public MakeCall
	public void makeCall (String des) {
		Socket socket;
		InputStream istream;
		OutputStream ostream;
		// Create socket connection with MCU
		try {
			socket = new Socket ("156.56.104.52", 7000);
			ostream = socket.getOutputStream ();
			istream = socket.getInputStream ();
			BufferedReader in = new BufferedReader (new InputStreamReader (istream));
		} catch (Exception e) {
			System.out.print ("Exception:"+e+"\n");
			return;
		}

		// send makecall commands
		if (ostream!=null) {
			try {
				ostream.write (("MakeCall "+des+"\r\n").getBytes ());
			} catch (Exception e) {
				System.out.println ("Exception: "+e+"\n");
			}
		}
		try {
			// cleanup
			if (istream!=null) {
				istream.close ();
			}
			if (ostream!=null) {
				ostream.close ();
			}
			if (socket!=null) {
				socket.close ();
			}
		} catch (IOException e) {
			return;
		}
		;
	}

}
