/**
 * Software License, Version 1.0
 *
 * Copyright 2003 The Trustees of Indiana University.  All rights reserved.
 *
 *
 *Redistribution and use in source and binary forms, with or without
 *modification, are permitted provided that the following conditions are met:
 *
 *1) All redistributions of source code must retain the above copyright notice,
 * the list of authors in the original source code, this list of conditions and
 * the disclaimer listed in this license;
 *2) All redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the disclaimer listed in this license in
 * the documentation and/or other materials provided with the distribution;
 *3) Any documentation included with all redistributions must include the
 * following acknowledgement:
 *
 *"This product includes software developed by the Community Grids Lab. For
 * further information contact the Community Grids Lab at
 * http://communitygrids.iu.edu/."
 *
 * Alternatively, this acknowledgement may appear in the software itself, and
 * wherever such third-party acknowledgments normally appear.
 *
 *4) The name Indiana University or Community Grids Lab or GlobalMMCS,
 * shall not be used to endorse or promote products derived from this software
 * without prior written permission from Indiana University.  For written
 * permission, please contact the Advanced Research and Technology Institute
 * ("ARTI") at 351 West 10th Street, Indianapolis, Indiana 46202.
 *5) Products derived from this software may not be called GlobalMMCS,
 * nor may Indiana University or Community Grids Lab or GlobalMMCS appear
 * in their name, without prior written permission of ARTI.
 *
 *
 * Indiana University provides no reassurances that the source code provided
 * does not infringe the patent or any other intellectual property rights of
 * any other entity.  Indiana University disclaims any liability to any
 * recipient for claims brought by any other entity based on infringement of
 * intellectual property rights or otherwise.
 *
 *LICENSEE UNDERSTANDS THAT SOFTWARE IS PROVIDED "AS IS" FOR WHICH NO
 *WARRANTIES AS TO CAPABILITIES OR ACCURACY ARE MADE. INDIANA UNIVERSITY GIVES
 *NO WARRANTIES AND MAKES NO REPRESENTATION THAT SOFTWARE IS FREE OF
 *INFRINGEMENT OF THIRD PARTY PATENT, COPYRIGHT, OR OTHER PROPRIETARY RIGHTS.
 *INDIANA UNIVERSITY MAKES NO WARRANTIES THAT SOFTWARE IS FREE FROM "BUGS",
 *"VIRUSES", "TROJAN HORSES", "TRAP DOORS", "WORMS", OR OTHER HARMFUL CODE.
 *LICENSEE ASSUMES THE ENTIRE RISK AS TO THE PERFORMANCE OF SOFTWARE AND/OR
 *ASSOCIATED MATERIALS, AND TO THE PERFORMANCE AND VALIDITY OF INFORMATION
 *GENERATED USING SOFTWARE.
 */
package cgl.globalmmcs.webserver.websrv;

/**
 * <p>Title: </p>
 * <p>Description: XGSP Conference Web Server</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Community Grids Lab, Indiana University</p>
 * @author Wenjun Wu, Harun Altay
 * @version 1.0
 */

import org.apache.axis.AxisFault;
import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import org.apache.axis.utils.Options;

import javax.xml.namespace.QName;

import javax.xml.rpc.ParameterMode;

import cgl.globalmmcs.webserver.*;
import cgl.globalmmcs.webserver.websrv.*;


/**
 * a SOAP client for invoking web service
 * @deprecated
 */
public class TestClient {
	public static void main (String[] args) throws Exception {
		Options options = new Options (args);
		Service service = new Service ();
		Call call = (Call) service.createCall ();
		QName qn = new QName ("urn:CommunityService", "Communityinfo");
		QName qn1 = new QName ("urn:CommunityService", "RoomBean");

		call.registerTypeMapping (Communityinfo.class, qn,
							 new org.apache.axis.encoding.ser.
							 BeanSerializerFactory (Communityinfo.class, qn),
							 new org.apache.axis.encoding.ser.
							 BeanDeserializerFactory (Communityinfo.class, qn));
		call.registerTypeMapping (RoomBean.class, qn1,
							 new org.apache.axis.encoding.ser.
							 BeanSerializerFactory (RoomBean.class, qn1),
							 new org.apache.axis.encoding.ser.
							 BeanDeserializerFactory (RoomBean.class, qn1));
		//Communityinfo result= new Communityinfo();
		RoomBean[] result = new RoomBean[] {};
		try {
			call.setTargetEndpointAddress (new java.net.URL (options.getURL ()));
			call.setOperationName (new QName ("CommunityServer", "getRoomList"));
			//call.addParameter( "arg1", qn, ParameterMode.IN );//?
			//call.setReturnType( org.apache.axis.encoding.XMLType.XSD_STRING );
			call.setReturnType (qn, Communityinfo.class);
			System.out.println ("help me!");
			//result = (Communityinfo)call.invoke( new Object[] {  } );
			result = (RoomBean[]) call.invoke (new Object[] {});

		} catch (AxisFault fault) {
			//result = "Error : " + fault.toString();
			String err_rpt = "Error : "+fault.toString ();
		}
		//System.out.println( result );

		//RoomBean[] roomlist = result.getRoomlist();
		RoomBean[] roomlist = result;
		for (int i = 0; i<roomlist.length; i++) {
			RoomBean room = roomlist[i];
			System.out.println (room.getRoomname ());
		}

	}
}