package cgl.globalmmcs.streaming.client;

import cgl.globalmmcs.sessionserver.net.*;
import java.util.*;

//import javax.jms.*;

public class RealJMSListener extends JMSClient {

  StreamingClientI streamingClient = null;
  //~ Constructors -------------------------------------------------------------

  /**
   * Creates a new JMSListener object.
   */
  public RealJMSListener() {
    this.loadProperties(propertiesFile);
  }

  /**
   * Creates a new JMSListener object.
   *
   * @param propFile DOCUMENT ME!
   */
  public RealJMSListener(String propFile) {
    loadProperties(propFile);
  }

  /**
   * Creates a new JMSListener object.
   *
   * @param brokerName DOCUMENT ME!
   * @param portNo DOCUMENT ME!
   * @param connectid DOCUMENT ME!
   * @param uname DOCUMENT ME!
   * @param pswd DOCUMENT ME!
   * @param subTopic DOCUMENT ME!
   * @param pubTopic DOCUMENT ME!
   */
  public RealJMSListener(String brokerName, String portNo, String connectid,
                     String uname, String pswd, String subTopic) {
    broker             = brokerName;
    port               = portNo;
    connectID          = connectid;
    username           = uname;
    password           = pswd;
    subscriptionTopics = subTopic;
    this.usePorpFile = false;
  }

  public void setStreamingClient(StreamingClientI stcl) {
    streamingClient = stcl;
  }

  //~ Methods ------------------------------------------------------------------

  /**
   * Generate topic and publisher
   */
  public void initJMSClient() {
    StringTokenizer topics      = new StringTokenizer(subscriptionTopics, ",");
    RealMsgListener     msgListener = new RealMsgListener(streamingClient);

    // Subscribe to Topics
    while (topics.hasMoreTokens()) {
      String topicName = topics.nextToken();
      new Subscription(session, topicName, msgListener);
    }
  }
}
