package cgl.globalmmcs.streaming.client;

import cgl.globalmmcs.sessionserver.messages.*;
import cgl.globalmmcs.sessionserver.messages.realgateway.*;
import cgl.globalmmcs.sessionserver.net.*;
import cgl.globalmmcs.sessionserver.util.*;

import java.util.*;

import javax.jms.*;

import javax.swing.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Pervasive Technology Labs, Indiana University</p>
 * @author Hasan Bulut
 * @version 1.1
 */
public class RealMsgListener implements javax.jms.MessageListener {
  //~ Instance fields ----------------------------------------------------------

  StreamingClientI streamingClient;

  //    private MessageHandler msgHandler = null;
  private SessionParser sp = new SessionParser();

  //~ Constructors -------------------------------------------------------------

  /**
   * Creates a new RealMsgListener object.
   *
   * @param stcl DOCUMENT ME!
   */
  public RealMsgListener(StreamingClientI stcl) {
    streamingClient = stcl;
    //      msgHandler = MessageHandler.getInstance();
  }

  //~ Methods ------------------------------------------------------------------

  /**
   * DOCUMENT ME!
   *
   * @param message DOCUMENT ME!
   */
  public void onMessage(javax.jms.Message message) {
    textMessageHandler(message);
  }

  /**
   * DOCUMENT ME!
   *
   * @param msg DOCUMENT ME!
   */
  public void textMessageHandler(javax.jms.Message msg) {
    Object key = new Object();
    try {
      sp.parse(((javax.jms.TextMessage) msg).getText());
      System.out.println("msg received:\n" +
                         ((javax.jms.TextMessage) msg).getText());
      if (streamingClient.isAdmin() && (sp.getRootElementName().equalsIgnoreCase("RequestAllStreamsReply"))) {
        RequestAllStreams ras = new RequestAllStreams();
        ras.setClass(sp.getRootElement());
/*
        if (!streamingClient.getSessionID().equals(ras.getSessionID())) {
          return;
        }
//*/
        if (streamingClient.getClientID().equals(ras.getClientID())) {
          java.util.List ls = new LinkedList();
          Map            mp = new HashMap();
          mp = ras.getVideoList().getStreams();
          ls = ras.getVideoList().getStreamList();
          for (int i = 0; i < ls.size(); i++) {
            String streamkey = ls.get(i).toString();
            if (!streamingClient.getLmsl().contains(streamkey)) {
              streamingClient.getLmsl().addElement(streamkey);
              streamingClient.getStreamMap().put(streamkey,
                                                 (StreamEvent) mp.get(streamkey));
              JPanel jp1 = streamingClient.getEventFrame((StreamEvent) mp.get(streamkey));
              streamingClient.getDeckMap().put(streamkey, jp1);
              streamingClient.getDeck().add(streamkey, jp1);
              streamingClient.pack();
            }
          }
          if(!streamingClient.getLmsl().isEmpty()) {
            streamingClient.getStreamsList().setSelectedIndex(0);

            streamingClient.pack();

          }
          streamingClient.repaint();
        }
        streamingClient.pack();
      } else if (streamingClient.isAdmin() && (sp.getRootElementName().equalsIgnoreCase("StreamEvent"))) {
        StreamEvent se = new StreamEvent();
        se.setClass(sp.getRootElement());
/*
        if (!streamingClient.getSessionID().equals(se.getSessionID())) {
          return;
        }
//*/
        System.out.println("media type:"+se.getMediaType());
        if(se.getMediaType().trim().equalsIgnoreCase("audio")) {
          System.out.println("calling return");
          return;
        }
        /*   "NewStreamEvent"; "ByeStreamEvent"; "ActiveToPassive"; "PassiveToActive"; "NullStreamEvent"; //*/
        String streamkey = se.getClient().getUsername() +
                           se.getClient().getSSRC();
        if (se.getEventType().equalsIgnoreCase("NewStreamEvent")) {
          if (!streamingClient.getLmsl().contains(streamkey)) {
            streamingClient.getLmsl().addElement(streamkey);
            streamingClient.getStreamMap().put(streamkey, se);
            JPanel jp1 = streamingClient.getEventFrame(se);
            streamingClient.getDeck().add(streamkey, jp1);
            streamingClient.getDeckMap().put(streamkey, jp1);
            if(!streamingClient.getLmsl().isEmpty()) {
              if (streamingClient.getStreamsList().getSelectedIndex() < 0) {
                streamingClient.getStreamsList().setSelectedIndex(0);
                streamingClient.pack();
              }
            }
            streamingClient.pack();
          }
        } else if (se.getEventType().equalsIgnoreCase("ByeStreamEvent")) {
          if (streamingClient.getLmsl().contains(streamkey)) {
            streamingClient.getLmsl().removeElement(streamkey);
            streamingClient.pack();
          }
/*
          if (streamingClient.getLmrs().contains(streamkey)) {
            streamingClient.getLmrs().removeElement(streamkey);
          }
//*/
          if (streamingClient.getStreamMap().containsKey(streamkey)) {
            System.out.println("inside streammap");
            JPanel jp1 = new JPanel();
            jp1 = (JPanel)streamingClient.getDeckMap().get(streamkey);
            streamingClient.getDeck().remove(jp1);
            streamingClient.getStreamMap().remove(streamkey);
            streamingClient.getDeckMap().remove(streamkey);
            streamingClient.getDeck().repaint();
            streamingClient.pack();
          }
/*
          if (streamingClient.getRealStreamMap().containsKey(streamkey)) {
            JPanel jp1 = new JPanel();
            jp1 = (JPanel)streamingClient.getRealDeckMap().get(streamkey);
            streamingClient.getRealDeck().remove(jp1);
            streamingClient.getRealStreamMap().remove(streamkey);
            streamingClient.getRealDeckMap().remove(streamkey);
            if(!streamingClient.getLmrs().isEmpty()) {
              streamingClient.getRealStreamsList().setSelectedIndex(0);
            }
//            streamingClient.getRealDeck().repaint();
            streamingClient.pack();
          }
//*/
          if(!streamingClient.getLmsl().isEmpty()) {
            if (streamingClient.getStreamsList().getSelectedIndex() < 0) {
              streamingClient.getStreamsList().setSelectedIndex(0);
              streamingClient.pack();
            }
          }
/*
          if(!streamingClient.getLmrs().isEmpty()) {
            if (streamingClient.getRealStreamsList().getSelectedIndex() < 0) {
              streamingClient.getRealStreamsList().setSelectedIndex(0);
              streamingClient.pack();
            }
          }
//*/
          streamingClient.pack();
        }
        streamingClient.pack();
      } else if (sp.getRootElementName().equalsIgnoreCase("RealStreamsReply")) {
        RealStreams rs = new RealStreams();
        System.out.println("root name:"+sp.getRootElementName());
        rs.setClass(sp.getRootElement());

        if(!streamingClient.isAdmin()) {
          if (!streamingClient.getSessionID().equals(rs.getSessionID())) {
            return;
          }
        }

        if (streamingClient.getClientID().equals(rs.getClientID())) {
          java.util.List ls = new LinkedList();
          ls = rs.getStreamIDList();
          System.out.println("list size:"+ls.size());
          streamingClient.clearRealStreamList();
          streamingClient.getRealStreamMap().clear();
          for (int i = 0; i < ls.size(); i++) {
            String streamkey = ls.get(i).toString();
            System.out.println("streamkey:"+streamkey);
            if (!streamingClient.getLmrs().contains(streamkey)) {
              System.out.println("element:"+streamkey);
              if(!streamingClient.isAdmin()) {
                if (!((RealStreamEvent) rs.getStreamList().get(streamkey)).
                    getSessionID().equalsIgnoreCase(streamingClient.
                    getSessionID())) {
                  return;
                }
              }
                streamingClient.getLmrs().addElement(streamkey);
                streamingClient.getRealStreamMap().put(streamkey,
                    rs.getStreamList().get(streamkey));
                RealStreamEvent rse = new RealStreamEvent();

                rse = (RealStreamEvent) rs.getStreamList().get(streamkey);
                /*
                              rse.setStreamID(streamkey);
                     rse.setRtspLink((rs.getStreamList().get(streamkey)).toString());
//*/
                JPanel jp1 = streamingClient.getEventFrame(rse);
                streamingClient.getRealDeckMap().put(streamkey, jp1);
                streamingClient.getRealDeck().add(streamkey, jp1);
                streamingClient.pack();
            }
          }
          if(!streamingClient.getLmrs().isEmpty()) {
            streamingClient.getRealStreamsList().setSelectedIndex(0);
            streamingClient.pack();
          }
          streamingClient.pack();
        }
        streamingClient.repaint();
      } else if (sp.getRootElementName().equalsIgnoreCase("RealStreamEvent")) {
        RealStreamEvent rse = new RealStreamEvent();
        rse.setClass(sp.getRootElement());
        System.out.println("RealStreamEvent\n"+rse.toXML("\n"));

        if(!streamingClient.isAdmin()) {
          if (!streamingClient.getSessionID().equals(rse.getSessionID())) {
            return;
          }
        }
        if (rse.getEventType().equalsIgnoreCase("NewRealStream")) {
          if (!streamingClient.getLmrs().contains(rse.getStreamID())) {
            streamingClient.getLmrs().addElement(rse.getStreamID());

            streamingClient.getRealStreamMap().put(rse.getStreamID(),rse);
//            streamingClient.getRealStreamMap().put(rse.getStreamID(),rse.getRtspLink());

           JPanel jp1 = streamingClient.getEventFrame(rse);
           streamingClient.getRealDeckMap().put(rse.getStreamID(), jp1);
           streamingClient.getRealDeck().add(rse.getStreamID(), jp1);
           streamingClient.pack();
          }
          if(streamingClient.getRealStreamsList().getSelectedIndex() < 0) {
            streamingClient.getRealStreamsList().setSelectedIndex(0);
            //streamingClient.
            streamingClient.pack();
          }
        } else if (rse.getEventType().equalsIgnoreCase("ByeRealStream")) {
          if (streamingClient.getLmrs().contains(rse.getStreamID())) {
            streamingClient.getLmrs().removeElement(rse.getStreamID());
            streamingClient.pack();
          }
          if (streamingClient.getRealStreamMap().containsKey(rse.getStreamID())) {
            JPanel jp1 = new JPanel();
            jp1 = (JPanel)streamingClient.getRealDeckMap().get(rse.getStreamID());
            streamingClient.getRealDeck().remove(jp1);
            streamingClient.getRealStreamMap().remove(rse.getStreamID());
            streamingClient.getRealDeckMap().remove(rse.getStreamID());
            streamingClient.getRealDeck().repaint();
            streamingClient.pack();
          }
          if(!streamingClient.getLmrs().isEmpty()) {
            if (streamingClient.getRealStreamsList().getSelectedIndex() < 0) {
              streamingClient.getRealStreamsList().setSelectedIndex(0);
//              streamingClient.pack();
            }
          }
        } else if(rse.getEventType().equalsIgnoreCase("RemoveAllStreams")) {
          streamingClient.getLmrs().clear();
          streamingClient.getRealDeck().removeAll();
          streamingClient.getRealStreamMap().clear();
          streamingClient.getRealDeckMap().clear();
          streamingClient.getRealDeck().repaint();
          streamingClient.pack();
        }
//        streamingClient.pack();
        streamingClient.pack();
      }
    } catch (JMSException ex) {
      System.out.println("Error in jms message type");
      ex.printStackTrace();
      return;
    }
  }
}
